***********************************************************************
* PROGRAMA DE CONSULTA, CADASTRO E COMPRA DE PRODUTOS
* PARA TR-300
*
* Utiliza uma base de dados (lista.dbf) onde esto cadastrados os 
* produtos, preos e cdigos.
* Um arquivo de indice (lista.ntx)
* Um arquivo texto (compra.txt) para armazenar os produtos vendidos, 
* seus preos e o numero de cada venda. 
*
***********************************************************************
************************************************************
* DECLARAO DE VARIAVEIS
************************************************************
N1=0
N2=0
c1=SPACE(15)
COD=0
A = 0
C3=SPACE(5)
t = .T.
SOMA=0
QUANT=0
SOMA1=0
QUANT1=0
VA=0
PA=SPACE(15)
FIM=0
N5=0
T2=.T.
I=0
COD2=0
NADA=0
COD1=0
FLAG=.T.
HORA=SPACE(8)
DATA1=SPACE(10)
P=0
************************************************************
* VETORES PARA ARMAZENAR ITENS COMPRADOS
************************************************************
DECLARE PRODUTOS(100,15)
DECLARE PRECOS(100,5)

************************************************************
* VARIAVEIS UTILIZADAS PARA ESCREVER DADOS NO ARQUIVO TEXTO
************************************************************
ARQUIVO=0
LF=""
LF=CHR(10)
PRE=SPACE(6)
QUA=SPACE(3)
QUA2=SPACE(2)
QUAVE=0
VENDA=SPACE(6)


COD=1
QUA2=STR(QUAVE,2,0)
USE LISTA INDEX LISTA
DO CADASTRAR

QUIT

*********************************************************************
PROCEDURE CADASTRAR
*********************************************************************
DO WHILE T=.T.


	DATA=DATE()
	DATA1=DTOC(DATA)
	HORA=TIME()
	@1,30 SAY DATA1
	@2,30 SAY HORA
	@1,1 SAY "VER LISTA DE PRODUTOS: 1"
	@2,1 SAY "CADASTRAR PRODUTO....: 2"

	
	P=INKEY()
	COD=1
	DO CASE
		CASE P=49
	
			DO LIMPA
			DO INICIO
	
		CASE P=50
	
			DO LIMPA
			DO ALTERAR
		
	ENDCASE
ENDDO
RETURN


*********************************************************************
PROCEDURE INICIO
*********************************************************************
DO LIMPA	
USE LISTA INDEX LISTA
@1,31 SAY "COMPRAR F1"
@2,15 SAY "CADASTRAR F2"
@2,31 SAY "ENCERRA F3"
@2,1 SAY "TOTAL:"
@2,7 SAY SOMA

DO WHILE T = .T.
	DO LIMPA2
	SET KEY -3 TO
	
	
	SEEK COD	
	FLAG=FOUND()
	CLEAR TYPEAHEAD
	IF FLAG=.F.
		DO LIMPA
		@1,1 SAY "NENHUM PRODUTO FOI CADASTRADO!"	
		DO DELAY
		DO CADASTRAR	
	ENDIF

	N1=CODIGO
	N2=PRECO
	C1=NOME
	


	@1,1 SAY COD
	@1,4 SAY C1
	@1,20 SAY N2

	A=INKEY(0)
	
	DO CASE 
        	CASE A=-1
			DO VOLTA
		CASE A=-2
			DO ALTERAR
		CASE A=-3
			DO ENCERRA
	        CASE A = 49
			COD=COD+1
        	CASE A = 48
			COD=COD-1
	ENDCASE	
	SEEK COD
	FLAG=FOUND()
     
	DO CASE 
		CASE COD=0
			GO BOTTOM
			COD=CODIGO
		CASE FLAG=.F.
			COD=1

	ENDCASE
      
ENDDO

RETURN

*********************************************************************
PROCEDURE ALTERAR
*********************************************************************

DO LIMPA  
SET KEY -3 TO INICIO
@1,1 SAY "NOVO PRODUTO:" 
@2,1 SAY "VALOR:"
@2,29 say "LISTA F3"
SET CURSOR ON
FLAG=.T.

*ALTERACAO DE PRODUTO*
PA="               "
@1,14 GET PA

*ALTERACAO DE PRECO*
VA=0
@2,7 GET VA
SET CURSOR OFF
GO BOTTOM
COD=CODIGO
COD=COD+1
APPEND BLANK
REPLACE CODIGO WITH COD 
REPLACE NOME WITH PA
REPLACE PRECO WITH VA
DO LIMPA
DO INICIO
RETURN
*********************************************************************
PROCEDURE ENCERRA
*********************************************************************
DO LIMPA
  
@1,1 SAY "EXIBIR LISTA DE"
@2,1 SAY "COMPRAS [ENTER]"
@1,20 SAY "ENCERRA DIA?"
@2,20 SAY "[S]IM [N]AO"
*N5=1

FIM=INKEY(0)
DO CASE
	CASE FIM=13 .AND. QUANT<1
		*T2=.T.
		DO LIMPA
		@1,5 SAY "NENHUM PRODUTO FOI ADICIONADO!"
		DO DELAY
		DO INICIO  
	
	CASE FIM=13

		DO WHILE T2 = .T.
			DO LIMPA
			C1=PRODUTOS[N5]
			C3=PRECOS[N5]

			@1,1 SAY N5
			@1,4 SAY C1
			@1,20 SAY C3
			@2,1 SAY "TOTAL:"
			@2,7 SAY SOMA
			@2,20 SAY "[V]OLTA"
			A=INKEY(0)
	
			DO CASE 
				CASE A=49  
					N5=N5+1
				CASE A=48
					N5=N5-1
				CASE A=86
					DO ENCERRA
					T2=.F.
			ENDCASE

			DO CASE 
				CASE N5=0
					N5=QUANT
				CASE N5>QUANT
					N5=1
			ENDCASE  

		ENDDO

		*ENDIF


	CASE FIM=78
		N5=0  		
		QUANT=0		
		SOMA=0
  		DO INICIO
	CASE FIM=83
		DO LIMPA

		DO WHILE T=.T.  
			@1,1 SAY "     TOTAL:"
			@2,1 SAY "QUANTIDADE:"
			@1,12 SAY SOMA1
			@2,12 SAY QUANT1
		ENDDO
		WAIT
		DO LIMPA
		SOMA1=0  
		QUANT1=0

	OTHERWISE
		DO ENCERRA
				
ENDCASE
  
 
RETURN

*********************************************************************
PROCEDURE VOLTA
*********************************************************************
DO LIMPA
*NADA=1
N5=N5+1
C3=STR(N2,5,2)

VENDA="VENDAS"   
PRODUTOS[N5]=C1
PRECOS[N5]=C3

SOMA=SOMA + N2
QUANT=QUANT +1
SOMA1=SOMA1 + N2
QUANT1=QUANT1 + 1 
QUA=STR(QUANT,3,0)

@1,1 SAY "VALOR TOTAL:"
@2,1 SAY "QUANTIDADE :    PRODUTO(S)" 
@1,14 SAY SOMA
@2,14 SAY QUANT
DO CASE
	CASE QUANT < 2
		QUAVE=QUAVE+1
		QUA2=STR(QUAVE,2,0)	  

		ARQUIVO=FOPEN("COMPRA.TXT")
		FSEEK(ARQUIVO,0,2)
		FWRITE(ARQUIVO,LF,1)
		FCLOSE(ARQUIVO)	

		ARQUIVO=FOPEN("COMPRA.TXT")
		FSEEK(ARQUIVO,0,2)
		FWRITE(ARQUIVO,VENDA,7)
		FWRITE(ARQUIVO,QUA2,2)
		FWRITE(ARQUIVO,LF,1)
		FCLOSE(ARQUIVO)	

		ARQUIVO=FOPEN("COMPRA.TXT")
		FSEEK(ARQUIVO,0,2)
		FWRITE(ARQUIVO,QUA,4)
		FWRITE(ARQUIVO,C1,15)
		FWRITE(ARQUIVO,C3,6)
		FWRITE(ARQUIVO,LF,1)
		FCLOSE(ARQUIVO)  

	CASE QUANT > 1
		ARQUIVO=FOPEN("COMPRA.TXT")
		FSEEK(ARQUIVO,0,2)
		FWRITE(ARQUIVO,QUA,4)
		FWRITE(ARQUIVO,C1,15)
		FWRITE(ARQUIVO,C3,6)
		FWRITE(ARQUIVO,LF,1)
		FCLOSE(ARQUIVO)
ENDCASE

*DO DELAY    
DO INICIO
RETURN
 
*********************************************************************
PROCEDURE LIMPA
*********************************************************************
@ 1,1 SAY "                                            "
@ 2,1 SAY "                                            "
RETURN

*********************************************************************
PROCEDURE DELAY
*********************************************************************
 FOR i=0 to 50
 NEXT
RETURN
*********************************************************************
PROCEDURE LIMPA2
*********************************************************************
  @ 1,1 SAY "                              "

RETURN